/* CalFolder internal component - Copyright (C) 2005 Rod Whiteley - Licensed under the Open Software License version 2.1 - Source at http://calendarhelp.mozdev.org/calfolder.html */
CalFolder = {
uuid: "{ca1f01de-441c-6bb8-7900-517f3463cd03}",version: "",once: false,tree: null,body: null,tabs: null,clock: null,inhibit: false,init: function () {
if (this.once) return
this.once = true
this.tree = document.getElementById("calfo-tree")
this.body = document.getElementById("calfo-children")
this.tabs = document.getElementById("tablist").firstChild
var tabIndex = this.tabs.parentNode.getAttribute("selectedIndex") || 0
this.color.init()
this.context.init()
this.rename.init()
this.drag.init()
this.prompt.init()
this.pref.init()
var pans = this.tabs.nextSibling
var pan = pans.firstChild
var tab = this.tabs.firstChild
while (pan) {
pan.setAttribute("label", tab.label)
tab = tab.nextSibling
pan = pan.nextSibling}
var mypanel = document.getElementById("calfo-panel")
pans.appendChild(mypanel.parentNode.removeChild(mypanel))
this.tabs.appendItem(mypanel.getAttribute("label"))
mypanel = document.getElementById("calfo-clock-panel")
this.clock = mypanel.firstChild
pans.appendChild(mypanel.parentNode.removeChild(mypanel))
var f = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("PrefD", Components.interfaces.nsIFile)
f.append("calfolder.rdf")
if (!f.exists()) this.setup(f)
var uri = Components.classes["@mozilla.org/network/protocol;1?name=file"].createInstance(Components.interfaces.nsIFileProtocolHandler).newFileURI(f)
this.data = document.getElementById("calfo-children").data
this.data.init(uri)
this.current.init()
this.tree.datasources = uri.spec
this.version = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager).datasource.GetTarget(
this.data.RDF.GetResource("urn:mozilla:item:" + this.uuid),this.data.RDF.GetResource("http://www.mozilla.org/2004/em-rdf#version"),true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value
if (this.pref.version != this.version) {
this.pref.version = this.version
setTimeout(function () {CalFolder.prompt.about()}, 0)}
this.pref.apply()
this.tabs.parentNode.selectedIndex = tabIndex
getCalendarManager().addObserver(this)
getDisplayComposite().addObserver(this)},setup: function (f) {
try {
f.create(0, 420)
var s = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream)
s.init(f, 0x24, 292, null)
var head = '<?xml version="1.0"?>'
+ '\n<!DOCTYPE RDF:RDF>'
+ '\n<RDF:RDF'
+ '\n\txmlns:CF="http://calendarhelp.mozdev.org/calfo#"'
+ '\n\txmlns:NC="http://home.netscape.com/NC-rdf#"'
+ '\n\txmlns:RDF="http://www.w3.org/1999/02/22-rdf-syntax-ns#">'
var all = '\n<RDF:Seq RDF:about="urn:calfo:all"'
+ ' CF:name="' + this.tree.getAttribute("alllabel") + '" CF:type="all">'
var def = '\n<RDF:Seq RDF:about="urn:calfo:set:default"'
+ ' CF:name="' + this.tree.getAttribute("defaultlabel") + '" CF:type="set">'
var mgr = getCalendarManager()
var active = getDisplayComposite()
var defcal = active.defaultCalendar
var cals = mgr.getCalendars({})
var n = 0
for each (var cal in cals) {
all += '\n\t<RDF:li><RDF:Description'
+ ' RDF:about="#setup' + n + '"'
+ ' CF:name="' + cal.name + '"'
+ ' CF:type="cal"'
+ ' CF:uri="' + cal.uri.spec + '"'
+ (cal == defcal ? ' CF:mark="on"' : '')
var clr = mgr.getCalendarPref(cal, "color") || "f9f4ff"
if (clr) {
clr = clr.replace(/^#/, "").toLowerCase()
this.color.reg(clr)
all += ' CF:color="s' + clr + '"'}
var uri = cal.uri
if (uri && uri.spec.indexOf("moz-") != 0) all += ' CF:remote="url"'
if (active.getCalendar(uri)) {
def += '\n\t<RDF:li><RDF:Description'
+ ' RDF:about="#def' + n + '"'
+ ' CF:name="' + cal.name + '"'
+ ' CF:type="cal"'
+ ' CF:uri="' + cal.uri.spec + '"'
+ (cal == defcal ? ' CF:mark="on"' : '')
def += '/></RDF:li>'}
all += '/></RDF:li>'
++n}
all += '\n</RDF:Seq>'
def += '\n</RDF:Seq>'
var root = '\n<RDF:Seq RDF:about="urn:calfo:root">'
+ '\n\t<RDF:li><RDF:Description RDF:about="urn:calfo:all"/></RDF:li>'
+ (n > 0 ?
'\n\t<RDF:li><RDF:Description RDF:about="urn:calfo:set:default"/></RDF:li>' :
'')
+ '\n</RDF:Seq>'
var tail = '\n</RDF:RDF>'
s.write(head, head.length)
s.write(all, all.length)
s.write(def, def.length)
s.write(root, root.length)
s.write(tail, tail.length)
s.close()}
catch (ex) {
alert("Calendar Folders can't create data file \n" + ex)}},drag: {
ctb: null,gesture: null,over: null,drop: null,init: function () {
this.ctb = document.getElementById("calendar-top-box")},fix: function (fix) {
with (this.ctb) {
if (fix) {
this.gesture = removeAttributeNode(getAttributeNode("ondraggesture"))
this.over = removeAttributeNode(getAttributeNode("ondragover"))
this.drop = removeAttributeNode(getAttributeNode("ondragdrop"))}
else {
setAttributeNode(this.gesture)
setAttributeNode(this.over)
setAttributeNode(this.drop)}}}},color: {
colors: {},sheet: null,popup: null,picker: null,data: null,tree: null,init: function () {
for each (var s in document.styleSheets) {
if (s.href == "chrome://calfolder/content/calfolder.css") {
this.sheet = s
break}}
var mgr = getCalendarManager()
var cals = mgr.getCalendars({})
for each (var cal in cals) {
var clr = mgr.getCalendarPref(cal, "color") || "f9f4ff"
if (clr) {
clr = clr.replace(/^#/, "").toLowerCase()
this.reg(clr)}}
this.popup = document.getElementById("calfo-colorpopup")
this.picker = document.getElementById("calfo-colorpicker")
this.data = CalFolder.data
this.tree = CalFolder.tree},change: function (x, y, res) {
var c = this.data.getColor(res) || "f9f4ff"
this.picker.initColor("#" + c)
x += this.tree.boxObject.x - 2
y += this.tree.boxObject.y + 2
this.popup.calfores = res
document.popupNode = CalFolder.body
setTimeout("CalFolder.color.popup.showPopup(document.documentElement," + x + ", " + y + ", 'popup', null, null)", 0)},pick: function () {
var res = this.popup.calfores
if (!res) return
var c = this.picker.color.replace(/^#/, "").toLowerCase()
if (CalFolder.pref.color) {
this.data.setColor(this.data.allRes(res), c)
this.data.lock(false, true)}
else this.data.setColor(res, c)
this.popup.hidePopup()
this.reg(c)
CalFolder.current.refresh()
this.popup.calfores = null},reg: function (clr) {
if (!clr || this.colors[clr]) return
with (this.sheet) insertRule(
'#calfo-tree treechildren::'
+ '-moz-tree-cell-text(s' + clr + ') '
+ '{color:#' + clr + ';'
+ ' background-color:#' + clr + ';'
+ ' border:1px dotted #444;}',cssRules.length)
this.colors[clr] = true}},rename: {
textbox: null,active: false,res: null,row: null,tree: null,body: null,data:null,init: function () {
this.textbox = document.getElementById("calfo-textbox")
this.tree = CalFolder.tree
this.body = CalFolder.body
this.data = CalFolder.data},exit: function (ok) {
if (ok == null && !this.active) return
if (ok) {
var v = this.textbox.value.replace(/^\s+|\s+$/g, "")
if (v) {
if (CalFolder.pref.name) {
this.data.setName(this.data.allRes(this.res), v)
this.data.lock(true, false)}
else this.data.setName(this.res, v)}}
this.textbox.setAttribute("hidden", "true")
this.active = false},focus: function () {
this.textbox.focus()
setTimeout("CalFolder.rename.active = true", 0)},key: function (event) {
switch (event.keyCode) {
case 9:
case 13:
this.exit(true)
break
case 27:
this.exit(false)
break}},popup: function (res, row) {
this.res = res, this.row = row
var box = CalFolder.tree.boxObject
var x = {}, y = {}
box.getCoordsForCellItem(row, box.columns.getNamedColumn("calfo-name"), "text", x, y, {}, {})
var w = this.tree.boxObject.width - x.value - 8
x = x.value + this.tree.boxObject.x - 2
y = y.value + this.tree.boxObject.y - 2
with (this.textbox) {
with (style) left = x + "px", top = y + "px", width = w + "px"
value = this.data.getName(res)
removeAttribute("hidden")
select()}
this.body.clearSelection()
setTimeout("CalFolder.rename.focus()", 0)}},context: {
menu: null,menu_default: null,menu_recolor: null,menu_reload: null,menu_delete: null,menu_select: null,tree: null,data: null,current: null,row: null,res: null,init: function () {
this.menu = document.getElementById("calfo-context")
this.menu_default = document.getElementById("calfo-default")
this.menu_recolor = document.getElementById("calfo-recolor")
this.menu_reload = document.getElementById("calfo-reload")
this.menu_delete = document.getElementById("calfo-delete")
this.menu_select = document.getElementById("calfo-select")
this.tree = CalFolder.tree
this.data = CalFolder.data
this.current = CalFolder.current},showing: function (event) {
var row = {}, col = {}, child = {}
this.tree.treeBoxObject.getCellAt(event.clientX, event.clientY, row, col, child)
var ix = row.value
this.row = ix
if (ix >= 0) {
var m = this.menu.firstChild
while (m.localName != "menuseparator") m = m.nextSibling
while (m) m.removeAttribute("hidden"), m = m.nextSibling
var res = this.data.res(ix)
var typ = this.data.getType(res)
if (typ == "cal") {
this.menu_select.setAttribute("hidden", "true")
if (this.data.getMark(res)) this.menu_default.setAttribute("checked", "true")
else this.menu_default.removeAttribute("checked")
if (!this.data.getRemote(res)) this.menu_reload.setAttribute("hidden", "true")}
else {
if (this.data.getMark(res)) this.menu_select.setAttribute("checked", "true")
else this.menu_select.removeAttribute("checked")
this.menu_default.setAttribute("hidden", "true")
this.menu_recolor.setAttribute("hidden", "true")
if (typ == "all") this.menu_delete.setAttribute("hidden", "true")}}
else {
var m = this.menu.firstChild
while (m.localName != "menuseparator") m = m.nextSibling
while (m) m.setAttribute("hidden", "true"), m = m.nextSibling}
this.res = res},makeDefault: function (res, row) {
if (!res) res = this.res
if (this.data.getType(res) == "cal" && !this.data.getMark(res))
this.data.setDefaultMark(res, this.data.seq(this.data.parentRes(row)))
this.res = null, this.row = null
this.data.write()},newFolder: function (res, row) {
var f = this.data.newSet(this.tree.getAttribute("newlabel"))
var ix = this.tree.builder.getIndexOfResource(f)
this.tree.treeBoxObject.ensureRowIsVisible(ix)
CalFolder.rename.popup(f, ix)},recolor: function (res, row) {
if (!res) res = this.res, row = this.row
var box = CalFolder.tree.boxObject
var x = {}, y = {}, h = {}
box.getCoordsForCellItem(row, box.columns.getNamedColumn("calfo-color"), "text", x, y, {}, h)
CalFolder.color.change(x.value, y.value + h.value, res)
this.res = null, this.row = null},reload: function (res, row) {
if (this.res) {
this.data.reload(this.res)
this.res = null, this.row = null}},remove: function (res, row) {
if (!res) res = this.res, row = this.row
var iscal = (this.data.getType(res) == "cal")
var ok = CalFolder.prompt.confirmDelete(this.data.getName(res), iscal)
if (ok) {
if (iscal) {
var cal = this.data.cal(res)
var spec = cal.uri.spec
var enf = this.data.seq(this.data.root).GetElements()
while (enf.hasMoreElements()) {
var f = this.data.seq(enf.getNext().QueryInterface(Components.interfaces.nsIRDFResource))
var enc = f.GetElements()
while (enc.hasMoreElements()) {
var c = enc.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
if (this.data.getURI(c) == spec) this.data.remove(c, f)}}
with (this.data.mgr) {
unregisterCalendar(cal)
this.data.mgr.deleteCalendar(cal)}}
else {
var seq = this.data.seq(res)
var enc = seq.GetElements()
while (enc.hasMoreElements()) {
var c = enc.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
this.data.remove(c, seq)}
this.data.remove(res, this.data.seq(this.data.root))}}
this.res = null, this.row = null},rename: function (res, row) {
if (!res) res = this.res, row = this.row
CalFolder.rename.popup(res, row)
this.res = null, this.row = null},properties: function (res, row) {
if (!res) res = this.res, row = this.row
dump("properties " + res.Value + "\n")
if (this.data.getType(res) == "set") {
var t = ""
var enum = this.data.seq(res).GetElements()
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource).Value
t += (e.indexOf("#") >= 0 ? e.replace(/^[^#]*/, "") : e) + "\n"}
alert(t)}
this.res = null, this.row = null},select: function (res, row) {
if (!res) res = this.res
if (this.data.getMark(res)) this.data.clearMark(res)
else if (this.data.getType(res) == "all") {
this.data.clearChecks()
this.data.setMark(res)}
else if (CalFolder.pref.single) {
this.data.clearChecks()
this.data.setMark(res)}
else {
this.data.clearMark(this.data.all)
this.data.setMark(res)}
this.res = res, this.row = row
setCursor("wait")
setTimeout(function () {CalFolder.context.selectNow()}, 0)},selectNow: function (res, row) {
var res = this.res, row = this.row
switch (this.data.getType(res)) {
case "all":
if (this.data.getMark(res)) this.current.folder(res, true)
else this.current.clear()
break
case "set":
if (this.data.getMark(res)) {
this.current.folder(this.data.all, false)
this.current.folder(res, true)}
else {
this.current.folder(res, false)}
break}
this.res = null, this.row = null
this.data.write()
setCursor("default")}},prompt: {
ps: null,ww: null,init: function () {
this.ps = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService)
this.ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher)},about: function () {
with (CalFolder.tabs.lastChild.boxObject) xpos = screenX, ypos = screenY + height
this.ww.openWindow(
self,"chrome://calfolder/content/about.xul","journal:login","chrome,resizable=no,dialog,screenx=" + xpos + ", screeny=" + ypos,null)},confirmDelete: function (name, iscal) {
var dat = document.getElementById(iscal ? "calfo-delcal" : "calfo-delset")
var v = {}
return this.ps.confirm(self,dat.getAttribute("title"),dat.getAttribute("text").replace(/\%/, name))}},pref: {
branch: null,init: function () {
this.branch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("calfolder.")},apply: function () {
var tabs = CalFolder.tabs
var pans = tabs.nextSibling
var p = tabs.parentNode.selectedPanel
var lblwas = p ? p.getAttribute("label") : ""
var pan = document.getElementById("calfo-clock-panel")
var ck = document.getElementById("clock")
var got = !ck.getAttribute("hidden")
var need = this.clock
if (need && !got) {
with (pans) insertBefore(removeChild(pan), firstChild)
pan.removeAttribute("hidden")
setTimeout(function () {document.getElementById("clock").start()}, 200)}
else if (got && !need) {
ck.stop()
pan.setAttribute("hidden", "true")
with (tabs) if (selectedIndex == 0) selectedIndex = 1
with (pans) appendChild(removeChild(firstChild))}
pan = document.getElementById("list-calendars-listbox").parentNode
got = !pan.getAttribute("hidden")
need = this.list
var ix = ck.getAttribute("hidden") ? 1 : 2
if (need && !got) {
with (pans) insertBefore(removeChild(pan), document.getElementById("calfo-panel"))
pan.removeAttribute("hidden")}
else if (got && !need) {
pan.setAttribute("hidden", "true")
with (pans) appendChild(removeChild(pan))}
var ix = 0
for (var i = 0, tab = tabs.firstChild, pan = pans.firstChild;
pan;
++i, pan = pan.nextSibling) {
var ntab = tab ? tab.nextSibling : null
if (pan.hasAttribute("hidden")) {
if (tab) tabs.removeItemAt(i--)}
else {
var l = pan.getAttribute("label")
if (tab) tab.label = l
else {
tab = tabs.appendItem(l)
if (pan.id) tab.id = pan.id + "-tab"}
if (l == lblwas) ix = i}
tab = ntab}
tabs.parentNode.selectedIndex = ix
with (CalFolder.clock) {
dateformat = this.dateformat
datelong = this.datelong
dateordinal = this.dateordinal
dateweek = this.dateweek
timeformat = this.timeformat
refresh()}
var ln = this.name, lc = this.color
if (ln || lc) CalFolder.data.lock(ln, lc)},get clock () {return this._value("display.clock", false)},set clock (v) {this.branch.setCharPref("display.clock", v)},get dateformat () {return this._value("date.format", false)},set dateformat (v) {this.branch.setIntPref("date.format", v)},get datelong () {return this._value("date.long", false)},set datelong (v) {this.branch.setBoolPref("date.long", v)},get dateordinal () {return this._value("date.ordinal", false)},set dateordinal (v) {this.branch.setBoolPref("date.ordinal", v)},get dateweek () {return this._value("date.week", false)},set dateweek (v) {this.branch.setBoolPref("date.week", v)},get list () {return this._value("display.list", false)},set list (v) {this.branch.setCharPref("display.list", v)},get color () {return this._value("lock.color", false)},set color (v) {this.branch.setCharPref("lock.color", v)},get name () {return this._value("lock.name", false)},set name (v) {this.branch.setCharPref("lock.name", v)},get single () {return this._value("single", false)},set single (v) {this.branch.setBoolPref("single", v)},get timeformat () {return this._value("time.format", false)},set timeformat (v) {this.branch.setIntPref("time.format", v)},get version () {return this._value("version", null)},set version (v) {this.branch.setCharPref("version", v)},_value: function (name, def) {
var t = null
try {t = this.branch.getPrefType(name);} catch (e) {}
if (!t) return def
try {
switch (t) {
case 32: return this.branch.getCharPref(name)
case 64: return this.branch.getIntPref(name)
case 128: return this.branch.getBoolPref(name)
default: return def}}
catch (e) {return def}}},current: {
data: null,now: null,seq: null,list: null,show: {},def: null,init: function () {
this.data = CalFolder.data
this.now = this.data.now
this.seq = this.data.seq(this.now)
this.list = document.getElementById("list-calendars-listbox")},clear: function () {
var enum = this.seq.GetElements()
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
this.seq.RemoveElement(e, false)}
this.setDefault(null, true)
this.refresh()},folder: function (res, add) {
var enum = this.data.seq(res).GetElements()
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var has = (this.seq.IndexOf(e) >= 0)
if (add && !has) {
this.seq.AppendElement(e)
if (this.data.getMark(e)) this.setDefault(e, false)}
else if (!add && has) {
this.seq.RemoveElement(e, true)}}
this.refresh()},refresh: function () {
var mgr = this.data.mgr
this.show = {}
this.def = null
var cals = mgr.getCalendars({})
for each (var cal in cals) this.show[cal.uri.spec] = cal.uri
var enum = this.data.seq(this.data.root).GetElements()
while (enum.hasMoreElements()) {
var f = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
if (this.data.getMark(f)) {
var cals = this.data.seq(f).GetElements()
while (cals.hasMoreElements()) {
var e = cals.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var cal = this.data.cal(e)
if (!cal) dump("current refresh no cal for " + this.data.getURI(e) + "\n")
var s = cal.uri.spec
if (!this.show[s].name) {
this.show[s] = cal
if (!this.def && this.data.getMark(e)) this.def = cal
var c = this.data.getColor(e)
CalFolder.inhibit = true
var clr = mgr.getCalendarPref(cal, 'color') || "f9f4ff"
if (c && c != clr.replace(/^#/, "").toLowerCase())
mgr.setCalendarPref(cal, 'color', "#" + c.toUpperCase())
var n = this.data.getName(e)
if (n != cal.name) cal.name = n
CalFolder.inhibit = false}}}}
var act = this.data.act
for (var s in this.show) {
var cal = this.show[s]
if (cal.name) try {act.addCalendar(cal)} catch (ex) {}
else try {act.removeCalendar(cal)} catch (ex) {}}
if (this.def) {
var s = this.def.uri.spec
var it = this.list.getItemAtIndex(0)
while (it) {
if (it.calendar.uri.spec == s) {
this.list.selectItem(it)
break}
it = this.list.getNextItem(it, 1)}}},setDefault: function (res, force) {
var d = this.data.getDefault(this.now)
if (d && !force) return
if (d) this.data.clearDefault(this.now)
if (res) this.data.setDefault(this.now, res.Value)}},QueryInterface: function(id) {
if (id.equals(Components.interfaces.nsISupports)
|| id.equals(Components.interfaces.calICalendarManagerObserver)
|| id.equals(Components.interfaces.calIObserver)
|| id.equals(Components.interfaces.calICompositeObserver))
return this
throw Components.results.NS_ERROR_NO_INTERFACE},onCalendarRegistered: function(cal) {
this.data.insert(
this.data.seq(this.data.all),this.data.newCal(cal),Infinity,false)},onCalendarUnregistering: function(cal) {
dump("onCalendarUnregistering \n")},onCalendarDeleting: function(cal) {},onCalendarPrefSet: function(cal, name, value) {
if (this.inhibit) return
if (name == "name") {
this.data.setName(this.data.allRes(cal.uri.spec), value)
this.data.write()}
if (name == "color") {
this.data.setColor(this.data.allRes(cal.uri.spec), value.replace(/^#/, "").toLowerCase())
this.data.write()}},onCalendarPrefDeleting: function(cal, name) {},onCalendarAdded: function (cal) {},onCalendarRemoved: function (cal) {},onDefaultCalendarChanged: function (cal) {},onStartBatch: function() {},onEndBatch: function() {},onLoad: function() {},onAddItem: function() {},onModifyItem: function() {},onDeleteItem: function() {},onAlarm: function() {},onError: function() {},data: {
RDF: null,CU: null,mgr: null,act: null,colorProp: null,defaultProp: null,markProp: null,nameProp: null,remoteProp: null,typeProp: null,uriProp: null,onLiteral: null,urlLiteral: null,netLiteral: null,tree: null,body: null,ds: null,root: null,all: null,now: null,init: function (uri) {
if (this.ds) return
this.RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService)
this.CU = Components.classes['@mozilla.org/rdf/container-utils;1'].getService(Components.interfaces.nsIRDFContainerUtils)
this.mgr = getCalendarManager()
this.act = getDisplayComposite()
this.ds = this.RDF.GetDataSourceBlocking(uri.spec)
const ns = "http://calendarhelp.mozdev.org/calfo#"
this.colorProp = this.RDF.GetResource(ns + "color")
this.defaultProp = this.RDF.GetResource(ns + "default")
this.nameProp = this.RDF.GetResource(ns + "name")
this.remoteProp = this.RDF.GetResource(ns + "remote")
this.typeProp = this.RDF.GetResource(ns + "type")
this.markProp = this.RDF.GetResource(ns + "mark")
this.uriProp = this.RDF.GetResource(ns + "uri")
this.onLiteral = this.RDF.GetLiteral("on")
this.urlLiteral = this.RDF.GetLiteral("url")
this.netLiteral = this.RDF.GetLiteral("net")
this.root = this.RDF.GetResource("urn:calfo:root")
this.all = this.RDF.GetResource("urn:calfo:all")
this.now = this.RDF.GetResource("urn:calfo:now")
this.tree = CalFolder.tree
this.body = CalFolder.body
var enf = this.seq(this.root).GetElements()
while (enf.hasMoreElements()) {
var f = enf.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var enc = this.seq(f).GetElements()
while (enc.hasMoreElements()) {
var c = enc.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
CalFolder.color.reg(this.getColor(c))}}},allRes: function (res) {
var u = (typeof res == "string")? res : this.getURI(res)
var enc = this.seq(this.all).GetElements()
while (enc.hasMoreElements()) {
var c = enc.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
if (this.getURI(c) == u) return c}},cal: function (res) {
var uri = this.getURI(res)
var cals = this.mgr.getCalendars({})
for each (var cal in cals) if (cal.uri.spec == uri) return cal},clearChecks: function () {
var enum = this.ds.GetSources(this.markProp, this.onLiteral, true)
while (enum.hasMoreElements()) {
var res = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
if (this.getType(res) != "cal") this.clearMark(res)}},clearDefault: function (res) {
var d = this.ds.GetTarget(res, this.defaultProp, true)
if (d) this.ds.Unassert(res, this.defaultProp, d)},clearMark: function (res) {
var m = this.ds.GetTarget(res, this.markProp, true)
if (m) this.ds.Unassert(res, this.markProp, m)},container: function (res) {
return this.CU.IsContainer(this.ds, res)},getColor: function (res) {
var c = this.ds.GetTarget(res, this.colorProp, true)
if (!c) return null
return c.QueryInterface(Components.interfaces.nsIRDFLiteral).Value.replace(/^s/, "")},getDefault: function (res) {
var d = this.ds.GetTarget(res, this.defaultProp, true)
return d ? d.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : null},getName: function (res) {
return this.ds.GetTarget(res, this.nameProp, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value},getRemote: function (res) {
var r = this.ds.GetTarget(res, this.remoteProp, true)
return r ? r.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : null},getType: function (res) {
var t = this.ds.GetTarget(res, this.typeProp, true)
return t ? t.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : null},getURI: function (res) {
var u = this.ds.GetTarget(res, this.uriProp, true)
return u ? u.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : null},getMark: function (res) {
var m = this.ds.GetTarget(res, this.markProp, true)
return m ? m.QueryInterface(Components.interfaces.nsIRDFLiteral).Value : null},insert: function (seq, res, ix, move) {
dump("insert " + ix + ", move " + move + "\n")
dump(" res type: " + this.getType(res) + "\n")
var a = []
var enum = seq.GetElements()
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
a.push(e)}
for (var i = 0; i < a.length; ++i) seq.RemoveElement(a[i], true)
var iscal = (this.getType(res) == "cal")
var spec = iscal ? this.cal(res).uri.spec : res.Value
for (var i = 0; i < a.length; ++i) {
var e = a[i]
if (i == ix) {
seq.AppendElement(res)
res = null}
if ((iscal ? this.cal(e).uri.spec : e.Value) != spec) {
seq.AppendElement(e)}
else {
if (move) this.remove(e)}}
if (res) seq.AppendElement(res.Resource ? res.Resource : res)},lock: function (doname, docolor) {
dump("lock " + doname + ", " + docolor + "\n")
var enf = this.seq(this.root).GetElements()
while (enf.hasMoreElements()) {
var f = enf.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
dump(" folder " + this.getName(f) + "\n")
var all = (f.Value == "urn:calfo:all")
var enc = this.seq(f).GetElements()
while (enc.hasMoreElements()) {
var c = enc.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var cal = this.cal(c)
if (all) {
if (doname) {
CalFolder.inhibit = true
var cn = this.getName(c)
if (cal.name != cn) cal.name = cn
CalFolder.inhibit = false}
if (docolor) {
CalFolder.inhibit = true
var cc = this.getColor(c)
if (cc && this.mgr.getCalendarPref(cal, 'color').replace(/^#/, "").toLowerCase() != cc)
this.mgr.setCalendarPref(cal, 'color', "#" + cc.toUpperCase())
CalFolder.inhibit = false}}
else {
if (doname) {
var cn = cal.name
if (this.getName(c) != cn) this.setName(c, cn)}
if (docolor) {
var cc = this.mgr.getCalendarPref(cal, 'color').replace(/^#/, "").toLowerCase()
if (cc && this.getColor(c) != cc) this.setColor(c, cc)}}}}},newCal: function (cal) {
var res = this.RDF.GetAnonymousResource()
this.setType(res, "cal")
this.setName(res, cal.name)
var u = cal.uri.spec
dump("setURI \n " + res.Value + "\n " + u + "\n")
this.setURI(res, u)
if (u.indexOf("moz-") != 0) this.setRemote(res, false)
this.setColor(res, this.mgr.getCalendarPref(cal, 'color'))
return res},newSet: function (name) {
var res = this.RDF.GetAnonymousResource()
this.setType(res, "set")
this.setName(res, name)
this.insert(this.seq(this.root), res, 1)
return res},parentRes: function (row) {
var p = this.tree.treeBoxObject.view.getParentIndex(row)
return p >= 0 ? this.tree.view.getResourceAtIndex(p) : this.root},reload: function (res) {
var cal = this.cal(res)
this.setRemote(res, true)
cal.uri = cal.uri
setTimeout(
function (res) {CalFolder.data.setRemote(res, false)},1100,res)},remove: function (res, seq) {
var enum = this.ds.ArcLabelsOut(res)
while (enum.hasMoreElements()) {
var p = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var t = this.ds.GetTarget(res, p, true)
if (t) this.ds.Unassert(res, p, t, true)}
if (!seq) return
var a = []
var enum = seq.GetElements()
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
a.push(e)}
for (var i = 0; i < a.length; ++i) seq.RemoveElement(a[i], true)
for (var i = 0; i < a.length; ++i) {
var e = a[i]
if (e.Value != res.Value) seq.AppendElement(e)}},res: function (row) {
return this.tree.view.getResourceAtIndex(row)},seq: function (ctr) {
return this.CU.MakeSeq(this.ds, ctr)},setColor: function (res, clr) {
if (!clr) return
var cl = clr.replace(/^#/, "").toLowerCase()
var t = this.ds.GetTarget(res, this.colorProp, true)
if (t) this.ds.Unassert(res, this.colorProp, t)
this.ds.Assert(res,this.colorProp,this.RDF.GetLiteral("s" + cl),true)
CalFolder.color.reg(cl)},setDefault: function (res, v) {
this.ds.Assert(res, this.defaultProp, this.RDF.GetLiteral(v), true)},setDefaultMark: function (res, seq) {
var enum = seq.GetElements()
while (enum.hasMoreElements()) {
var e = enum.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
this.clearMark(e)}
this.setMark(res)},setMark: function (res) {
this.ds.Assert(res, this.markProp, this.onLiteral, true)},setName: function (res, n) {
var p = this.ds.GetTarget(res, this.nameProp, true)
if (p) this.ds.Unassert(res, this.nameProp, p)
if (n) this.ds.Assert(res, this.nameProp, this.RDF.GetLiteral(n), true)},setRemote: function (res, net) {
this.ds.Assert(
res,this.remoteProp,(net ? this.netLiteral : this.urlLiteral),true)},setType: function (res, t) {
this.ds.Assert(res, this.typeProp, this.RDF.GetLiteral(t), true)},setURI: function (res, u) {
this.ds.Assert(res, this.uriProp, this.RDF.GetLiteral(u), true)},uriRes: function (uri) {
return this.ds.GetSource(this.uriProp, this.RDF.GetLiteral(uri.spec), true)},write: function () {
this.ds.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush()}},toString: function () {
return "[object CalFolder]"}}
addEventListener(
"load",function () {CalFolder.init()},false)
